<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->


<script setup lang="ts">
import { ref } from 'vue';
import { Float, FloatArrow } from '@headlessui-float/vue';
import type { Placement } from '@floating-ui/vue';


const props = defineProps<{
    tooltip?: string,
    placement?: string,
    width?: string,
    offset?: number,
}>();

const emits = defineEmits<{
    (e: 'click', value:any):void,
}>();

const isShowing = ref(false);
const handleShow = () => {
    isShowing.value = true;

}

const handleHide = () => {
    isShowing.value = false;
}

const handleClick = (event:any)=>{
    emits('click', event);
}

</script>
<template>
    <Float :placement="((placement ?? 'top') as Placement)" :show="isShowing" :arrow="5" :offset="offset?offset:0" flip shift portal zIndex="10000" v-if="tooltip && tooltip.length>0">
        <div @mouseover="handleShow" @mouseleave="handleHide" @click="handleClick">
            <slot></slot>
        </div>
        <div class="flex items-center justify-center" :class="width" v-if="tooltip" role="tooltip">
            <FloatArrow class="absolute bg-gray-500 w-3 h-3 rotate-45" />
            <div class="relative bg-gray-500 px-2 py-0.5 text-white text-center rounded-md" v-html="tooltip"></div>
        </div>
    </Float>
</template>